package com.example.civilizedcity.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.Date;
import java.util.List;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

 /**
 * 问题表;
 * @author : http://www.chiner.pro
 * @date : 2022-12-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "问题表",description = "")
@TableName("ta_issue")
public class TaIssue implements Serializable,Cloneable{
      /** 问题ID */
      @ApiModelProperty(name = "问题ID",notes = "")
      @TableId(value = "issue_id", type = IdType.AUTO)
      private Integer issueId ;
      /** 标题 */
      @ApiModelProperty(name = "标题",notes = "")
      private String title ;
      /** 所属分类 */
      @ApiModelProperty(name = "所属分类",notes = "")
      private String typeId ;
      /** 分类名称 */
      @ApiModelProperty(name = "分类名称",notes = "")
      private String typeName ;
      /** 点位ID */
      @ApiModelProperty(name = "点位ID",notes = "")
      private String locId ;
       /** 点位名称 */
       @ApiModelProperty(name = "点位名称",notes = "")
       private String locName ;
      /** 定位 */
      @ApiModelProperty(name = "定位",notes = "")
      private String location ;
      /** 具体位置 */
      @ApiModelProperty(name = "具体位置",notes = "")
      private String addr ;
      /** 问题详情 */
      @ApiModelProperty(name = "问题详情",notes = "")
      private String content ;
      /** 流程节点 */
      @ApiModelProperty(name = "流程节点",notes = "")
      private String processNode ;
      /** 处理状态 */
      @ApiModelProperty(name = "处理状态",notes = "")
      private String processStatus ;
       /** 截止时间;YYYY-MM-DD */
       @ApiModelProperty(name = "截止时间",notes = "YYYY-MM-DD")
       private String expireDate ;
      /** 交办次数 */
      @ApiModelProperty(name = "交办次数",notes = "")
      private Integer processNum ;
      /** 责任单位 */
      @ApiModelProperty(name = "责任单位",notes = "")
      private String orgId ;
      /** 来源类型;feedback市民上报,check模拟测评 */
      @ApiModelProperty(name = "来源类型",notes = "feedback市民上报,check模拟测评")
      private String sourceType ;
      /** 来源ID */
      @ApiModelProperty(name = "来源ID",notes = "")
      private String sourceTarget ;

       /** 当前申请类型 */
       @ApiModelProperty(name = "当前申请类型",notes = "")
       private String applyType ;
       /** 当前申请ID */
       @ApiModelProperty(name = "当前申请ID",notes = "")
       private Integer applyId ;

       /** 审核状态 */
       @ApiModelProperty(name = "审核状态",notes = "")
       private Integer validateStatus ;
      /** 状态 */
      @ApiModelProperty(name = "状态",notes = "")
      private Integer status ;
      /** 上报人 */
      @ApiModelProperty(name = "上报人",notes = "")
      private String createUser ;
      /** 上报人名称 */
      @ApiModelProperty(name = "上报人名称",notes = "")
      private String userName ;
      /** 上报人身份 */
      @ApiModelProperty(name = "上报人身份",notes = "")
      private String userDuty ;
      /** 创建时间 */
      @ApiModelProperty(name = "创建时间",notes = "")
      private LocalDateTime createDate ;
      /** 更新人 */
      @ApiModelProperty(name = "更新人",notes = "")
      private String updateUser ;
      /** 更新时间 */
      @ApiModelProperty(name = "更新时间",notes = "")
      private LocalDateTime updateDate ;


      @TableField(exist = false)
       @ApiModelProperty(name = "文件列表",notes = "")
      private List<TaAttach> attachList;
}