package com.example.civilizedcity.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.example.civilizedcity.common.Constants;
import com.example.civilizedcity.common.StringUtils;
import com.example.civilizedcity.entity.SysUser;
import com.example.civilizedcity.entity.TaIssue;
import com.example.civilizedcity.entity.TaIssueProcess;
import com.example.civilizedcity.mapper.TaIssueMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.example.civilizedcity.entity.TaOrgIssue;
import com.example.civilizedcity.mapper.TaOrgIssueMapper;
import com.example.civilizedcity.service.TaOrgIssueService;

import java.time.LocalDateTime;

/**
 * 单位问题单;(ta_org_issue)表服务实现类
 *
 * @author : http://www.chiner.pro
 * @date : 2022-12-28
 */
@Service
public class TaOrgIssueServiceImpl extends BaseServiceImpl<TaOrgIssueMapper, TaOrgIssue> implements TaOrgIssueService {

    @Autowired
    TaIssueMapper taIssueMapper;

    @Override
    public IPage<TaIssue> getIssuePageBy(IPage<TaIssue> pg, String orgId, String sourceType, String bizStatus) {

        String processNode = null;
        Boolean isExpire = false;

        if (!StringUtils.isEmpty(bizStatus)) {
            if ("expire".equals(bizStatus)) {
                isExpire = true;
            } else {
                processNode = bizStatus;
            }
        }

        return baseMapper.getIssuePageBy(pg, orgId, sourceType, processNode, isExpire);
    }

    @Override
    public void createNewIssue(TaIssue taIssue, SysUser sysUser) {
        TaOrgIssue taOrgIssue = new TaOrgIssue();
        taOrgIssue.setIssueId(taIssue.getIssueId());
        taOrgIssue.setOrgId(taIssue.getOrgId());
        taOrgIssue.setProcessStatus(Constants.PROCESS_START);
        taOrgIssue.setStatus(Constants.STATUS_NORMAL);
        taOrgIssue.setCreateDate(LocalDateTime.now());
        taOrgIssue.setCreateUser(sysUser.getUserId());

        save(taOrgIssue);
    }

    @Override
    public void removeByIssueId(String issueId){
       baseMapper.removeByIssueId(issueId);
        taIssueMapper.removeByIssueId(issueId);
    }

}